"use strict";
var JsonSerializer = (function () {
    function JsonSerializer() {
    }
    JsonSerializer.serializeToArray = function (jsonObject, keys, path) {
        keys = keys || [];
        path = path || "";
        if (jsonObject instanceof Array) {
            if (jsonObject.length) {
                for (var keyName in jsonObject) {
                    if (keyName) {
                        var keyValue = jsonObject[keyName];
                        var elementName = path + "[" + keyName + "]";
                        JsonSerializer.serializeToArray(keyValue, keys, elementName);
                    }
                }
            }
            else {
                keys[path] = jsonObject;
            }
        }
        else if (jsonObject instanceof Object) {
            for (var keyName in jsonObject) {
                if (keyName) {
                    var keyValue = jsonObject[keyName];
                    var elementName = "" + keyName;
                    if (path && typeof path === "string") {
                        elementName = path + "." + keyName;
                    }
                    JsonSerializer.serializeToArray(keyValue, keys, elementName);
                }
            }
        }
        else {
            keys[path] = jsonObject;
        }
        return keys;
    };
    JsonSerializer.serializeToObject = function (arr) {
        var jsonObject = {};
        for (var key in arr) {
            if (key) {
                var value = arr[key];
                var path = key.split(".");
                var temporaryObject = jsonObject;
                for (var pathIndex = 0; pathIndex < path.length; pathIndex++) {
                    var currentKey = path[pathIndex];
                    var isArray = /\[([0-9]+)\]$/;
                    if (isArray.test(currentKey)) {
                        var arrayIndex = currentKey.match(isArray)[1];
                        var formattedCurrentKey = currentKey.replace(isArray, "");
                        temporaryObject[formattedCurrentKey] = temporaryObject[formattedCurrentKey] || [];
                        if (pathIndex + 1 < path.length) {
                            temporaryObject[formattedCurrentKey][arrayIndex] = temporaryObject[formattedCurrentKey][arrayIndex] || {};
                            temporaryObject = temporaryObject[formattedCurrentKey][arrayIndex];
                        }
                        else {
                            temporaryObject[formattedCurrentKey][arrayIndex] = value;
                        }
                    }
                    else {
                        if (!(currentKey in jsonObject)) {
                            temporaryObject[currentKey] = temporaryObject[currentKey] || {};
                        }
                        if (pathIndex === (path.length - 1)) {
                            temporaryObject[currentKey] = value;
                        }
                        else {
                            temporaryObject[currentKey] = temporaryObject[currentKey] || {};
                            temporaryObject = temporaryObject[currentKey];
                        }
                    }
                }
            }
        }
        return jsonObject;
    };
    return JsonSerializer;
}());
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = JsonSerializer;
